#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Dec 19 13:10:08 2024

Führt Operationen auf Testsets ohne Kenntnis der Klassen durch.

@author: user
"""
import math
import copy
import pickle


#
# Ausdrucken einer Matrix (zeilenweise)
#
def PrintMatrix(a):
    print("-------- Matrix begin -----------")
    for i in range(len(a)):
        print(', '.join(f'{q:.2f}' for q in a[i]))
    print("-------- Matrix end   -----------")


#
# Metrik: Abstand zweier Punkte
#
def Metrik(p1,p2):
    d=0
    for i in range(len(p1)):
        q=p1[i] - p2[i]
        d=d+q*q
    return math.sqrt(d)    
        
        
        
        
        
#
# Erstellt eine Distanzmatrix (Dreiecksmatrix)
#
def Distance(a):
    m=[]
    for i in range(len(a)):
        d=[]
        for j in range(i,len(a)):
            d.append(Metrik(a[i],a[j]))
        m.append(d)        
    return m    


#
# Ermittlung der Extrema in der Distanzmatrix
#
def MinMax(b):
    mi=1000
    ma=0
    for i in range(len(b)-1):
        for j in range(1,len(b)-i):
            mi=min(mi,b[i][j])
            ma=max(ma,b[i][j])
    r=[mi,ma]
    return r        



#
# Sucht Punktpaare,deren Abstand eine bestimmte Größe nicht überchreitet
#
def GetInitalPairs(a,b,r):
    p=[]
    rg = len(a)
    for i in range(rg-1):
        for j in range(1,rg-i):
            if(r >= b[i][j]):
                p.append([i,i+j])
    return p                



#
# Verdichtet Punktpaare aus der vorhergehenden Funktion auf zusammen
# gehörende Punktlisten
# Die Verdichtung erfolgt rekursiv, da getrennte Listen entstehen können,
# obwohl Punkte zusammen gehören
#
def CompressPairs(pts):
    cp = []
    il=len(pts)
    while len(pts) > 0:
        ps = copy.copy(pts[0])
        pts.pop(0)
        i=0
        while i < len(pts):
            for j in range(len(pts[i])):
                if(pts[i][j] in ps):
                    ps = ps + pts[i]
                    pts.pop(i)
                    break
            else:
                i=i+1
        cp.append(list(dict.fromkeys(ps)))
    
    if(len(cp) < il):
        return CompressPairs(cp)
    return cp        


#
# Berechnet den Schwerpunkt einer Punktliste
#
def MidPoint(ptlist,a):
    pl=[]
    for k in range(len(ptlist)):
        ptl=copy.deepcopy(ptlist[k])
        p=copy.deepcopy(a[ptl[0]])
        for i in range(1,len(ptl)):
            for j in range(len(a[0])):
                p[j] = p[j] + a[ptl[i]][j]
            
        for j in range(len(a[0])):
            p[j] = p[j] / len(ptl)
         
        pl.append(p)        
    return pl

#
# Schwerpunkt, die nahe aneinander liegen, zusammen fassem
#
def CompressMidPoint(pl,r):
    pres = []
    for i in range(len(pl)):
        p = copy.deepcopy(pl[i])
        d = 0
        for j in range(i+1,len(pl)):
            for k in range(len(p)):
                q = pl[i][k] - pl[j][k]
                d = d + q*q
                
        
#
# Sichern und Rücklesen einer Liste in eine Datei
#
def WriteList(a,name):
    with open(name, "wb") as fp:
        pickle.dump(a, fp)
        
        
def ReadList(name):
    with open(name, "rb") as fp:   # Unpickling
        return pickle.load(fp)        
