#
# Erzeugen eines Feldes mit Daten, die in Klassen getrennt werden sollen
#

import testset as iset
import groups as grp
import matplotlib.pyplot as plt
import time


dim=3
kls=6
pts=20

                             # Erstelle ein Testset oder lese eines ein
gen_set = True              # Testset ohne Variation
setname = "testset0.bin"     # Name des Testsets

if(gen_set):    
    a = iset.InitSet(dim,kls,pts)
    iset.WriteList(a,setname)
else:
    a = iset.ReadList(setname)
    
iset.PlotSet(a)
plt.show()
print(a)
time.sleep(1)


mod_set = True               # Modifiziere die Punkte eines Testsets
mod_name = "modset0.bin"      # Name des modifizierten Sets
mod_val = [2.5,2.5,2.5,2.50,2.5,2.5,2.5,2.5]   # Streuung der Klassen

if(mod_set):
    for i in range(kls):
        a=iset.ModifyClass(a, i, mod_val[i])
    grp.WriteList(a, mod_name) 
else:
    a = grp.ReadList(mod_name)
    
iset.PlotSet(a)
plt.show()
time.sleep(1)



b=grp.Distance(a)               # Erstelle Distanzmatrix
c= grp.MinMax(b)                # Suche min/max der Distanzen
#grp.PrintMatrix(b)
print(c)


ofs = 5

pair = grp.GetInitalPairs(a, b,  ofs) 
print("Primary Pairs:",pair)
pair = grp.CompressPairs(pair)
print("Compressed Pairs:",pair)
#for i in range(len(pair)):
#    pair[i].sort()
#print("Compressed Pairs:",pair)

n=0
for i in range(len(pair)):
    n = n + len(pair[i])
print(len(pair)," Gruppen gefunden mit Punktabstand < ",c[0]+ofs," zwischen zwei Punkten einer Gruppe")    
if(n < len(a)):    
    print(n," von ",len(a)," Punkten zugeordnet")
    for i in range(len(a)):
        for j in range(len(pair)):
            if(i in pair[j]):
                break
        else:
            print("Pinkt ",i,"=",a[i]," nicht gefunden")
elif n > len(a):
    print(n-len(a)," Punkte mehrfach zugeordent")            
else:
    print("alle ",len(a)," Punkte gruppiert")    
            


midp=grp.MidPoint(pair,a)

ab = grp.Distance(midp)

print(ab)


iset.GroupPlotSet(a, midp, 5.5 )
plt.show()
